<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-list-item
    @click="$emit('selected', item)"
  >
    <v-list-item-avatar>
      <v-icon 
        :class="status.colorStatus"
      >mdi-cogs</v-icon>
    </v-list-item-avatar>
    <v-list-item-content>
    <v-list-item-title>
      
      <template v-if="item['one-time']">
        <v-icon small>mdi-rocket-launch-outline</v-icon> This is a one-time benchmark.
        <div v-if="item.provider">Provider: <span class="highlight">{{item.provider.name}}</span></div>
        <div v-else><v-icon small color="orange">mdi-alert</v-icon> No provider info available for this execution (not authorized)</div>
      </template>
      <template v-else>
        <div v-if="item.provider">Provider: <span class="highlight">{{item.provider.name}}</span></div>
        <div v-else><v-icon small color="orange">mdi-alert</v-icon> No provider info available for this execution (not authorized)</div>
        <span v-if="item.schedule">Schedule is <span class="highlight">{{item.schedule.name}}</span></span>
        <span v-else><v-icon small color="orange">mdi-alert</v-icon> No schedule info available (not authorized).</span>
      </template>
      

      <div v-if="status.isRunning">Status: <span class="RUNNING">RUNNING</span></div>
      <div v-else-if="status.allFailed">Status: <span class="RED">FAILED ({{status.num_failed}} tests)</span></div>
      <div v-else-if="status.allOk">Status: <span class="GREEN">SUCCESS ({{status.num_ok}} tests)</span></div>
      <div v-else>Status: <span class="YELLOW">SOME ERRORS ({{status.num_ok}} ok/{{status.num_failed}} failed)</span></div>

    </v-list-item-title>
    <v-list-item-subtitle>
      Start time: {{new Date(Date.parse(item.starttime))}}<br/>
      Execution Id: {{item.id}}
    </v-list-item-subtitle>
    <v-list-item-subtitle>
    </v-list-item-subtitle>
    
    </v-list-item-content>
  </v-list-item>

</template>

<script>

export default {

  name: 'ExecutionSummary',

  props: {
    item: {
      type: Object,
      default: function() {return {}}
    }
  },
  
  computed: {
    status: function() {
      const res = {
        isRunning: this.item.status == 'RUNNING'
      }

      if(res.isRunning) {
        console.log(this.item)
      }

      if(!res.isRunning) {
        res.num_ok = this.item.runs_status.ok.length
        res.num_failed = this.item.runs_status.error.length
      }
      res.isFinished = !res.isRunning
      res.allFailed = res.num_ok == 0
      res.allOk = res.num_failed == 0 && res.num_ok > 0

      if(res.allOk) {
        res.colorStatus = 'GREEN'
      } else if(res.allFailed) {
        res.colorStatus = 'RED'
      } else {
        res.colorStatus = 'YELLOW'
      }

      return res
    },
    resources: function() {
      // build flavours dict
      var dict = {};
      for(var i in this.item.schedule.service_types) {
        var st = this.item.schedule.service_types[i];
        var image = st.image;
        if(!dict[image])
          dict[image]=[];
        dict[image].push(st.size);
      }
      // now build the output
      var out = "";
      for(i in dict) {
        out+=i+" (";
        for(var j in dict[i])
          out+=dict[i][j]+", ";
        out=out.substring(0, out.length-2);
        out+=")"
      }
      return out;
    }  
  }

};

</script>

<style>

  .GREEN {
    color: green;
    background: #e0ffe0;
  }

  .RED {
    color: red;
    background: #ffe0e0;
  }

  .YELLOW {
    color: rgb(192, 125, 0);
    background: #ffe2c3;
  }

  .RUNNING {
    color: rgb(130, 177, 255);
    color: rgb(25, 118, 210);
    background: #f0f0ff;
  }

  .highlight {
    font-weight: bold;
    color: rgb(80, 80, 80)
  }
</style>